#!/usr/local/bin/perl -w

$infile = "hmmscan.out";
$outfile = "DomainComposition.out";

&find_domains;

sub find_domains {
    open (INPUT, "$infile") or die "Can't open $infile: $!";
    $#domains = -1;
    $#starts = -1;
    $#ends = -1;
    $#evals = -1;
    for $line (<INPUT>) {
        $line =~ s/\n//;
        unless ($line =~ /^#/) {
            @fields = split (/\s+/, $line);
            $#domains++;
            $#starts++;
            $#ends++;
            $#evals++;
            $domains[$#domains] = $fields[0];
            $starts[$#starts] = $fields[17];
            $ends[$#ends] = $fields[18];
            $evals[$#evals] = $fields[11];
        }
    }
    close INPUT;
    open (OUTPUT, ">$outfile") or die "Can't open $outfile: $!";
    print OUTPUT "----------------------------------------------------------------------\n";
    if ($#domains >= 0) {
        $istart = 0;
        $iend = $#domains - 1;
        for $i ($istart .. $iend) {
            $min = $i;
            $jstart = $i + 1;
            $jend = $#domains;
            for $j ($jstart .. $jend) {
                if ($evals[$j] < $evals[$min]) {
                    $min = $j;
                }
            }
            if ($min > $i) {
                $temp = $domains[$min];
                $domains[$min] = $domains[$i];
                $domains[$i] = $temp;
                $temp = $starts[$min];
                $starts[$min] = $starts[$i];
                $starts[$i] = $temp;
                $temp = $ends[$min];
                $ends[$min] = $ends[$i];
                $ends[$i] = $temp;
                $temp = $evals[$min];
                $evals[$min] = $evals[$i];
                $evals[$i] = $temp;
            }
        }
        $#finaldomains = -1;
        $#finalstarts = -1;
        $#finalends = -1;
        $#finalevals = -1;
        $finaldomains[0] = $domains[0];
        $finalstarts[0] = $starts[0];
        $finalends[0] = $ends[0];
        $finalevals[0] = $evals[0];
        for $i (1 .. $#domains) {
            $overlap = 0;
            for $j (0 .. $#finaldomains) {
                unless (($ends[$i] <= $finalstarts[$j]) or ($starts[$i] >= $finalends[$j])) {
                    $overlap = 1;
                    last;
                }
            }
            if ($overlap == 0) {
                $#finaldomains++;
                $#finalstarts++;
                $#finalends++;
                $#finalevals++;
                $finaldomains[$#finaldomains] = $domains[$i];
                $finalstarts[$#finalstarts] = $starts[$i];
                $finalends[$#finalends] = $ends[$i];
                $finalevals[$#finalevals] = $evals[$i];
            }
        }
        $istart = 0;
        $iend = $#finaldomains - 1;
        for $i ($istart .. $iend) {
            $min = $i;
            $jstart = $i + 1;
            $jend = $#finaldomains;
            for $j ($jstart .. $jend) {
                if ($finalstarts[$j] < $finalstarts[$min]) {
                    $min = $j;
                }
            }
            if ($min > $i) {
                $temp = $finaldomains[$min];
                $finaldomains[$min] = $finaldomains[$i];
                $finaldomains[$i] = $temp;
                $temp = $finalstarts[$min];
                $finalstarts[$min] = $finalstarts[$i];
                $finalstarts[$i] = $temp;
                $temp = $finalends[$min];
                $finalends[$min] = $finalends[$i];
                $finalends[$i] = $temp;
                $temp = $finalevals[$min];
                $finalevals[$min] = $finalevals[$i];
                $finalevals[$i] = $temp;
            }
        }
        for $i (0 .. $#finaldomains) {
            print OUTPUT "$finaldomains[$i]\t$finalstarts[$i]\t$finalends[$i]\t$finalevals[$i]\n";
        }
    } else {
        print OUTPUT "No Pfam domains detected\n";
    }
    close OUTPUT;
}
